﻿#version 300 es
in mediump vec2 vTex;
uniform lowp sampler2D samplerFront;
uniform lowp sampler2D samplerBack;
uniform mediump vec2 srcOriginStart;
uniform mediump vec2 srcOriginEnd;
uniform mediump vec2 destStart;
uniform mediump vec2 destEnd;
uniform mediump float compression;
uniform mediump float gradient;
out lowp vec4 outColor;

void main(void)
{
	lowp vec4 front = texture(samplerFront, vTex);
	mediump vec2 srcOriginSize = srcOriginEnd - srcOriginStart;

	mediump vec2 sampleTex = vTex;
	mediump float nYDist = abs(vTex.y - srcOriginStart.y);
	sampleTex.y += nYDist + nYDist * compression;
	mediump vec2 n = ((sampleTex - srcOriginStart) / srcOriginSize);
	lowp vec4 back = texture(samplerBack, mix(destStart, destEnd, n));
	
	outColor = back * front.a * (1. - ((vTex - srcOriginStart) / srcOriginSize).y * gradient);
}
