﻿%%SAMPLERFRONT_BINDING%% var samplerFront : sampler;
%%TEXTUREFRONT_BINDING%% var textureFront : texture_2d<f32>;

%%SAMPLERBACK_BINDING%% var samplerBack : sampler;
%%TEXTUREBACK_BINDING%% var textureBack : texture_2d<f32>;

struct ShaderParams {
	compression : f32,
	gradient : f32
};

%%SHADERPARAMS_BINDING%% var<uniform> shaderParams : ShaderParams;

%%C3PARAMS_STRUCT%%

%%FRAGMENTINPUT_STRUCT%%
%%FRAGMENTOUTPUT_STRUCT%%

@fragment
fn main(input : FragmentInput) -> FragmentOutput
{
	var front : vec4<f32> = textureSample(textureFront, samplerFront, input.fragUV);
	let srcOriginSize: vec2<f32> = abs(c3Params.srcOriginEnd - c3Params.srcOriginStart);

	var sampleTex: vec2<f32> = input.fragUV;
	let nYDist: f32 = abs(input.fragUV.y - c3Params.srcOriginStart.y);
	sampleTex.y -= nYDist + nYDist * shaderParams.compression;

	let n : vec2<f32> = ((sampleTex - c3Params.srcOriginStart) / srcOriginSize);
	var back : vec4<f32> = textureSample(textureBack, samplerBack, mix(c3Params.destStart, c3Params.destEnd, n));

	var output : FragmentOutput;
	output.color = back * front.a * (1. - ((input.fragUV - c3Params.srcOriginStart) / srcOriginSize).y * shaderParams.gradient);
	return output;
}
